package com.gxwebsoft.love.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.*;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.UserService;
import com.gxwebsoft.love.entity.ChatMessage;
import com.gxwebsoft.love.param.ChatMessageParam;
import com.gxwebsoft.love.service.ChatMessageService;
import com.gxwebsoft.love.socketio.cache.ClientCache;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 聊天消息表控制器
 *
 * @author 科技小王子
 * @since 2023-06-10 18:27:25
 */
@Api(tags = "聊天消息表管理")
@RestController
@RequestMapping("/api/love/chat-message")
public class ChatMessageController extends BaseController {
    @Resource
    private ChatMessageService chatMessageService;

    @Resource
    private UserService userService;


    @Resource
    private ClientCache clientCache;
    @OperationLog
    @ApiOperation("发送消息：app端使用")
    @PostMapping("/app/send")
    public ApiResult<?> sendMessage(@RequestBody ChatMessage message) {
        User loginUser = getLoginUser();
        message.setFormUserId(getLoginUserId());
        message.setFormUserInfo(loginUser);
        return success(chatMessageService.sendMessage(message));
    }

    @OperationLog
    @ApiOperation("发送消息")
    @GetMapping("/app/list/{friendId}")
    public ApiResult<List<ChatMessage>> listApp(@PathVariable Integer friendId) {

        return success(chatMessageService.getFriendMessage(getLoginUserId(), friendId));
    }

    @PreAuthorize("hasAuthority('love:chatMessage:list')")
    @OperationLog
    @ApiOperation("分页查询聊天消息表")
    @GetMapping("/page")
    public ApiResult<PageResult<ChatMessage>> page(ChatMessageParam param) {
        PageParam<ChatMessage, ChatMessageParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
//        return success(chatMessageService.page(page, page.getWrapper()));
        // 使用关联查询
        return success(chatMessageService.pageRel(param));
    }



    @PreAuthorize("hasAuthority('love:chatMessage:list')")
    @OperationLog
    @ApiOperation("查询全部聊天消息表")
    @GetMapping()
    public ApiResult<List<ChatMessage>> list(ChatMessageParam param) {
        PageParam<ChatMessage, ChatMessageParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(chatMessageService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(chatMessageService.listRel(param));
    }

    @PreAuthorize("hasAuthority('love:chatMessage:list')")
    @OperationLog
    @ApiOperation("根据id查询聊天消息表")
    @GetMapping("/{id}")
    public ApiResult<ChatMessage> get(@PathVariable("id") Integer id) {
        return success(chatMessageService.getById(id));
        // 使用关联查询
        //return success(chatMessageService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('love:chatMessage:save')")
    @OperationLog
    @ApiOperation("添加聊天消息表 管理员使用")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ChatMessage message) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        User fromUser = userService.getById(message.getFormUserId());
        message.setFormUserInfo(fromUser);
        if (chatMessageService.sendMessage(message)) {
            return success("发送成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('love:chatMessage:update')")
    @OperationLog
    @ApiOperation("修改聊天消息表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ChatMessage chatMessage) {
        if (chatMessageService.updateById(chatMessage)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('love:chatMessage:remove')")
    @OperationLog
    @ApiOperation("删除聊天消息表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (chatMessageService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('love:chatMessage:save')")
    @OperationLog
    @ApiOperation("批量添加聊天消息表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ChatMessage> list) {
        if (chatMessageService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('love:chatMessage:update')")
    @OperationLog
    @ApiOperation("批量修改聊天消息表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ChatMessage> batchParam) {
        if (batchParam.update(chatMessageService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('love:chatMessage:remove')")
    @OperationLog
    @ApiOperation("批量删除聊天消息表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (chatMessageService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
